(*
:Program.       CX
:Contents.      Ersatz fr das Commodities Exchange Programm
:Author.        Fin Schuppenhauer
:Copyright.     Postcardware
:Language.      Modula-2
:Translator.    M2Amiga V4.301d
:History        2.2 Fin Schuppenhauer 29.05.95 (Aminet)
:History        2.1 Fin Schuppenhauer 10.05.95 (Aminet)
:History        2.0 Fin Schuppenhauer 26.04.95 (Aminet)
:History.       1.3 Fin Schuppenhauer 19.09.94 (Aminet)
:History.       1.1 Fin Schuppenhauer 13.09.94 (Aminet)
:History.       1.0 Fin Schuppenhauer 06.09.94
:Address.       Fin Schuppenhauer, Braupark 10, 20537 Hamburg
:Address.       E-Mail: 1schuppe@informatik.uni-hamburg.de
*)
MODULE CX;

   (* CX.mod - Ersatz fr das "Exchange"-Programm der Workbench
    * Version     : $VER: CX.mod 2.3 ( 1995 Fin Schuppenhauer)
    * Autor       : Fin Schuppenhauer
    *               Braupark 10
    *               20537 Hamburg
    *               (Germany)
    * E-Mail      : 1schuppe@informatik.uni-hamburg.de
    * Erstellt am : 23 Jan 1995
    * Letzte nd. : 11 Jul 1995
    *)

    (*$ DEFINE DEBUG:=FALSE *)

IMPORT
    el:ExecL,
    dd:DosD,
    cxw:CXWindow,
    cxc:CXCommodity,
    cxr:CXARexx;

(*$ IF DEBUG *)
IMPORT io:InOut;
(*$ ENDIF *)

FROM SYSTEM IMPORT
    LONGSET, CAST;

(* --------------------------------------------------------------- *)

PROCEDURE CleanUp;
(* Alles aufrumen und uns vom System verabschieden. Bye, bye... *)
BEGIN
    (*$ IF DEBUG *)
    io.WriteString ("CleanUp...\n");
    (*$ ENDIF *)
    cxw.CloseWindow;
    cxc.FreeBroker;
    cxr.FreeARexx;
END CleanUp;

(* --------------------------------------------------------------- *)

PROCEDURE Schubidu;
(* Hauptprogramm-Warteschleife. Nachrichten empfangen und dann
 * reagieren.
 *)
VAR
    done: BOOLEAN;
    rcvdsigs, waitsigs: LONGSET;
BEGIN
    (*$ IF DEBUG *)
    io.WriteString ("Schubidu...\n");
    (*$ ENDIF *)
    done := FALSE;

    WHILE NOT(done) DO
        waitsigs := LONGSET{dd.ctrlC,cxc.brokersignal,cxw.windowsignal,cxr.arexxsignal};
        rcvdsigs := el.Wait(waitsigs);
        IF cxw.windowsignal IN rcvdsigs THEN
            cxw.HandleWindowMsg (done);
        END;
        IF cxc.brokersignal IN rcvdsigs THEN
            cxc.HandleBrokerMsg (done);
        END;
        IF cxr.arexxsignal IN rcvdsigs THEN
            cxr.HandleARexxMsg (done);
        END;
        IF dd.ctrlC IN rcvdsigs THEN
            done := TRUE;
        END;
    END;
END Schubidu;

BEGIN (* main *)
    (*$ IF DEBUG *)
    io.WriteString ("Module CX loaded...\n");
    (*$ ENDIF *)
    IF cxr.InitARexx() THEN
        IF cxc.InitBroker() THEN
            Schubidu;
        END;
    END;

    CleanUp;
END CX.
